## 
## PSPDictionary
## Copyright (C) 2010,2011 Germano Fabio
## gefasio@gmail.com
## 
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
##

import osl
from offline import TradOffline
from online import *

osl.initGfx(osl.PF_8888, True) 
osl.setQuitOnLoadFailure(True) 
osl.setFrameskip(1) 

class Application(object):
    def __init__(self):
        self.splash = osl.Image("img/splash.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.bg = []
        self.bg.append(osl.Image("img/matita_sel.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888))
        self.bg.append(osl.Image("img/lente_sel.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888))
        self.bg.append(osl.Image("img/ok_sel.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888))
        self.bg.append(osl.Image("img/crono_sel.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888))
        self.bgLenteOn = osl.Image("img/lente_sel_on.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.qualeBg = 0
        self.mask = osl.Image((480,272), osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.mask.clear(osl.RGBA(255,255,255,0))
        self.fnt = osl.Font("font.oft")
        osl.setTextColor(osl.RGBA(255,255,255,255))
        osl.setBkColor(osl.RGBA(255,255,255,0))
        self.fnt.set()
        self.textbar = osl.Image("img/textbar.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.box_trad_off = osl.Image("img/box_trad_off.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.box_connecting = osl.Image("img/box_conn.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.box_chron = osl.Image("img/box_chron.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.box_no_trad = osl.Image("img/box_no_trad.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.switch = [osl.Image("img/off.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888),\
                       osl.Image("img/on.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)]
        self.l_r = osl.Image("img/l_r.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
        self.val = '' # For the osk
        self.modalita = 'offline' # It can be: 'offline' or 'online'.
        self.tradotto = 0 # 0 -> Non ancora tradotto; 1 -> Tradotto offline; 2 -> Tradotto online.
        self.connecting = False
        self.connected = False
        self.trad = None

        ## Var for chron
        self.showChronIndex = 0
        self.chron = ''
        self.showChron = False

        ## Var for offLine Mode
        self.vocabolariOff = {0:"English",1:"Italiano",2:"Francais",3:"Deutsche",4:"Espanol"}
        self.vocabolarioOff = 0

        self.server = 0 # 0 -> 'it.babelfish.yahoo.com/', 1 -> 'langtolang.com', 2 -> 'translate.google.com'
        self.serverDaVis = 0

        ## Var for BabelFlish server
        self.indiceOnlineBabel = 0
        self.lingueOnlineBabel = {0:'it_en',1:'it_fr',2:'fr_it',3:'en_it',4:'en_nl',5:'en_fr',6:'en_de',7:'en_es',8:'en_pt',\
                                 9:'pt_en',10:'pt_fr',11:'es_en',12:'es_fr',13:'nl_en',14:'nl_fr',15:'fr_nl',16:'fr_en',17:'fr_de',\
                                 18:'fr_pt',19:'fr_es',20:'de_en',21:'de_fr'}
        self.visualizzazioniOnlineBabel = {'it':'Italiano','en':'English','fr':'Francais','nl':'Nederlands','de':'Deutsche','pt':'Portugues',\
                                           'es':'Espanol'}
        self.traduzioniBabel = []

        ## Var for langtolang server
        self.indiceOnlineLang = 0
        self.lingueOnlineLang = {0:'english->italian', 1:'english->french',2:'english->german', 3:'english->spanish', 4:'italian->english',\
                                 5:'italian->french',  6:'italian->german',7:'italian->spanish',  8:'french->english', 9:'french->italian',\
                                 10:'french->german',11:'french->spanish',  12:'german->english',  13:'german->italian', 14:'german->french',\
                                 15:'german->spanish',  16:'spanish->english',  17:'spanish->italian',  18:'spanish->french', 19:'spanish->german'}
        self.traduzionilang = ''
        self.qualeVisLang = 0

        ## Var for Google translate server
        self.indiceOnlineGoogle = 0
        ## Per i dizionari, usiamo gli stessi di langtolang :-)
        self.traduzioniGoogle = ''
        
        self.Update()
        
    def updateOSK(self):
        osl.drawOsk()
        if osl.getDialogType():
            osl.drawDialog()
        if osl.getOskStatus() == 0:
            if osl.oskGetResult() == osl.OSK_CANCEL:
                osl.endOsk()
            else:
                self.val = osl.oskGetText()
                osl.endOsk()
        
##    def AddToChron(self, parola):
##        try:
##            fl = open("chronology","r")
##            buftemp = fl.read()
##            buf = buftemp.split(",")
##            fl.close()
##        except:
##            buf = []
##        if len(buf) == 10:
##            buf.pop(9)
##            buf.insert(0,parola)
##        else:
##            buf.append(parola)
##        fl = open("chronology","w")
##        fl.write(",".join(buf))
##        fl.close()
##    def ExtractChron(self):
##        fl = open("chronology","r")
##        buftemp = fl.read()
##        buf = buftemp.split(",")
##        fl.close()
##        return buf
    def ExtractChron(self):
        fl = open('translations.txt','r')
        buf = fl.read().split("-----------------------------------------------")
        del buf[len(buf)-1]
        return buf
    def TradOnline(self, server, indiceLingua):
        if server == 0:
            self.traduzioniBabel = Traduci('it.babelfish.yahoo.com/', self.val, self.lingueOnlineBabel[indiceLingua],'')
            self.box_no_trad = osl.Image("img/box_no_trad_babel.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
            self.serverDaVis = 0
            langFrom = self.visualizzazioniOnlineBabel[self.lingueOnlineBabel[indiceLingua].split("_")[0]]
            langTo = self.visualizzazioniOnlineBabel[self.lingueOnlineBabel[indiceLingua].split("_")[1]]
            self.saveTranslation(self.traduzioniBabel, 'it.babelfish.yahoo.com', langFrom, langTo)
            return self.traduzioniBabel
        elif server == 1:
            self.traduzionilang = Traduci('langtolang.com', self.val, self.lingueOnlineLang[indiceLingua].split('->')[0],self.lingueOnlineLang[indiceLingua].split('->')[1])
            self.box_no_trad = osl.Image("img/box_no_trad_lang.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
            self.serverDaVis = 1
            self.saveTranslation(';'.join(self.traduzionilang), 'langtolang.com', self.lingueOnlineLang[indiceLingua].split('->')[0], self.lingueOnlineLang[indiceLingua].split('->')[1])
            return self.traduzionilang
        elif server == 2:
            self.box_no_trad = osl.Image("img/box_no_trad_google.png", osl.IN_RAM | osl.SWIZZLED, osl.PF_8888)
            self.serverDaVis = 2
            self.pLang = self.lingueOnlineLang[indiceLingua].split('->')[0][0:2]
            self.sLang = self.lingueOnlineLang[indiceLingua].split('->')[1][0:2] 
            if self.lingueOnlineLang[indiceLingua].split('->')[0] == 'spanish':
                self.pLang = 'es'
            elif self.lingueOnlineLang[indiceLingua].split('->')[1] == 'spanish':
                self.sLang = 'es'
            if self.lingueOnlineLang[indiceLingua].split('->')[0] == 'german':
                self.sLang = 'de'
            elif self.lingueOnlineLang[indiceLingua].split('->')[1] == 'german':
                self.sLang = 'de'
            self.traduzioniGoogle = Traduci('google.translate.com', self.val, self.pLang+'|'+self.sLang,'')
            self.saveTranslation(self.traduzioniGoogle, 'translate.google.com', self.lingueOnlineLang[indiceLingua].split('->')[0], self.lingueOnlineLang[indiceLingua].split('->')[1])
            return self.traduzioniGoogle
    def showOnlineTrad(self, server):
        if server == 0 and self.traduzioniBabel != '':
            osl.drawString(22, 80, 'Traslating from babelfish.yahoo.com')
            osl.drawString(22, 105, self.traduzioniBabel)
        elif server == 1 and len(self.traduzionilang) != 0:
            osl.drawString(22, 80, 'Traslating from langtolang.com (results found: %s)' % (len(self.traduzionilang)))
            i = 0
            y = 0
            for trad in self.traduzionilang:
                if i >= self.qualeVisLang and i < self.qualeVisLang + 8:
                    osl.drawString(22, 100+10*y, trad)
                    y += 1
                i += 1
        elif server == 2 and self.traduzioniGoogle != '':
            osl.drawString(22, 80, 'Traslating from translate.google.com')
            osl.drawString(22, 105, self.traduzioniGoogle)
    def saveTranslation(self, translation = '', server = '', from_ = '', to = ''):
        self.fl = open('translations.txt','r')
        if self.fl.read() == '':
            self.fl.close()
            self.fl = open('translations.txt','a')
            self.fl.write("\n")
        else:
            self.fl.close()
            self.fl = open('translations.txt','a')
        if self.modalita == 'offline':
            self.fl.write('Mode: ' + self.modalita+'\n'+\
                          'Word: ' + self.val+'\n'+\
                          'Translated in English: ' + self.trad.traduzioni[0] + '\n'+\
                          'Translated in Italiano: ' + self.trad.traduzioni[1] + '\n'+\
                          'Translated in Francais: ' + self.trad.traduzioni[2] + '\n'+\
                          'Translated in Deutsche: ' + self.trad.traduzioni[3] + '\n'+\
                          'Translated in Espanol: ' + self.trad.traduzioni[4] + '\n'+\
                          'Translated in Latin: ' + self.trad.traduzioni[5] + '\n'+\
                          '-----------------------------------------------\n')
        else:
            self.fl.write('Mode: ' + self.modalita+'\n'+\
                          'Server: ' + server+'\n'+\
                          'Word\Sentence: ' + self.val+'\n'+\
                          'Translation from %s to %s:\n%s \n'%(from_, to, translation)+\
                          '-----------------------------------------------\n')
        self.fl.close()
    def Update(self):
        skip = False

        ## Visualizzo IWDC splash screen.
        for i in range(150):
            if not skip: 
                osl.startDrawing()
                self.splash.draw()
                osl.endDrawing()
            skip = osl.syncFrame() 
            osl.endFrame() 
        self.mask.clear(osl.RGBA(255,255,255,0))
        ##
        
        while not osl.mustQuit(): 
            if not skip: 
                osl.startDrawing()
                self.pad = osl.Controller()

                self.bg[self.qualeBg].draw()
                osl.setTextColor(osl.RGBA(0,0,0,255)) 
                osl.drawString(18, 45, self.val)
                osl.setTextColor(osl.RGBA(255,255,255,255))

                if self.showChron == True:
                    if self.pad.pressed_left and self.showChronIndex != 0:
                        self.showChronIndex -= 1
                    elif self.pad.pressed_right and self.showChronIndex != len(self.chron)-1:
                        self.showChronIndex += 1
                    
                    if self.pad.pressed_triangle:
                        self.showChronIndex = len(self.chron)-1
                        self.showChron = False
                        
                if self.pad.released_cross and self.qualeBg == 0 and not self.connecting:
                    if not osl.oskIsActive():
                        osl.initOsk("Enter some text to translate", self.val, 128, 1)
                elif self.pad.released_cross and self.qualeBg == 1:
                    if self.modalita == 'offline':
                        self.vocabolarioOff += 1
                        if self.vocabolarioOff > 4:
                            self.vocabolarioOff = 0
                elif self.pad.released_square and self.qualeBg == 1:
                    if self.modalita == 'online':
                        if self.server == 0: # 'it.babelfish.yahoo.com/'
                            self.indiceOnlineBabel -= 1
                            if self.indiceOnlineBabel < 0:
                                self.indiceOnlineBabel = 21
                        elif self.server == 1: # 'langtolang.com'
                            self.indiceOnlineLang -= 1
                            if self.indiceOnlineLang < 0:
                                self.indiceOnlineLang = 19
                        elif self.server == 2: # 'google.translate.com'
                            self.indiceOnlineGoogle -= 1
                            if self.indiceOnlineGoogle < 0:
                                self.indiceOnlineGoogle = 19
                elif self.pad.released_triangle and self.qualeBg == 1:
                    if self.modalita == 'online':
                        if self.server == 0: # 'it.babelfish.yahoo.com/'
                            self.indiceOnlineBabel += 1
                            if self.indiceOnlineBabel > 21:
                                self.indiceOnlineBabel = 0
                        elif self.server == 1: # 'langtolang.com'
                            self.indiceOnlineLang += 1
                            if self.indiceOnlineLang > 19:
                                self.indiceOnlineLang = 0
                        elif self.server == 2: # 'google.translate.com'
                            self.indiceOnlineGoogle += 1
                            if self.indiceOnlineGoogle > 19:
                                self.indiceOnlineGoogle = 0
                if self.pad.released_cross and self.qualeBg == 1:
                    if self.modalita == 'online' and self.server != 0:
                        self.server -= 1
                elif self.pad.released_circle and self.qualeBg == 1:
                    if self.modalita == 'online' and self.server != 2:
                        self.server += 1
                if self.pad.released_cross and self.qualeBg == 2 and self.modalita == 'offline'  and not self.connecting:
                    self.trad = TradOffline(self.vocabolarioOff, self.val)
                    self.saveTranslation()
                    self.tradotto = 1
                elif self.pad.released_cross and self.qualeBg == 2 and self.modalita == 'online':
                    if self.server == 0:
                        self.TradOnline(self.server, self.indiceOnlineBabel)
                    elif self.server == 1:
                        self.qualeVisLang = 0
                        self.TradOnline(self.server, self.indiceOnlineLang)
                    elif self.server == 2:
                        self.TradOnline(self.server, self.indiceOnlineGoogle)
                    self.tradotto = 2
                if self.pad.released_cross and self.qualeBg == 3:
                    self.showChron = True
                if self.qualeBg == 1:
                    if self.modalita == 'offline':
                        osl.drawString(216, 250-2, self.vocabolariOff[self.vocabolarioOff])
                    elif self.modalita == 'online':
                        self.bgLenteOn.draw()
                        osl.setTextColor(osl.RGBA(0,0,0,255)) 
                        osl.drawString(18, 45, self.val)
                        osl.setTextColor(osl.RGBA(255,255,255,255))
                        if self.server == 0: # 'it.babelfish.yahoo.com/'
                            osl.drawString(80, 262-6, 'babelfish.yahoo.com')
                            self.daVis = self.lingueOnlineBabel[self.indiceOnlineBabel]
                            self.daVis1 = self.daVis.replace(self.daVis[0:2],self.visualizzazioniOnlineBabel[self.daVis[0:2]])
                            self.daVis2 = self.daVis.replace(self.daVis[3:5],self.visualizzazioniOnlineBabel[self.daVis[3:5]])
                            osl.drawString(140, 248-6, self.daVis1[0:len(self.daVis1)-3] + '->'+ self.daVis2[3:len(self.daVis1)])
                        elif self.server == 1: # 'langtolang.com/'
                            osl.drawString(80, 262-6, 'langtolang.com (only words)')
                            osl.drawString(140, 248-6, self.lingueOnlineLang[self.indiceOnlineLang])
                        elif self.server == 2: # 'google.translate.com/'
                            osl.drawString(80, 262-6, 'translate.google.com')
                            osl.drawString(140, 248-6, self.lingueOnlineLang[self.indiceOnlineGoogle])
                elif self.qualeBg == 3:
                    if self.pad.pressed_cross:
                        self.showChron = True
                        self.chron = self.ExtractChron()
                        self.showChronIndex = len(self.chron)-1
                            
                if self.pad.released_left and self.qualeBg != 0 and not osl.oskIsActive() and not self.connecting and not self.showChron:
                    self.qualeBg -= 1
                elif self.pad.released_right and self.qualeBg != 3 and not osl.oskIsActive() and not self.connecting and not self.showChron:
                    self.qualeBg += 1
                if self.tradotto == 1: ## Tradotto offline. Visualizzo traduzioni.
                    self.box_trad_off.draw(15, 73)
                    try:
                        osl.drawString(87, 87-2, self.trad.traduzioni[1])
                        osl.drawString(87, 102-2, self.trad.traduzioni[0])
                        osl.drawString(87, 116-2, self.trad.traduzioni[2])
                        osl.drawString(87, 129-2, self.trad.traduzioni[3])
                        osl.drawString(87, 144-2, self.trad.traduzioni[4])
                        osl.drawString(87, 158-2, self.trad.traduzioni[5])
                    except:
                        pass
                elif self.tradotto == 2: ## Tradotto online. Visualizzo traduzioni.
                    self.box_no_trad.draw(15, 73)
                    self.showOnlineTrad(self.serverDaVis) 
                if self.pad.released_R  and not osl.oskIsActive() and not self.showChron:
                    ## Connecting
                    if not self.connected:
                        osl.initNetDialog()
                        self.connecting = True
                    else:
                        self.modalita = 'online'
                elif self.pad.released_L and not osl.oskIsActive() and not self.showChron:
                    self.modalita = 'offline'
                        
                if self.modalita == 'offline':
                    self.switch[0].draw(156, 2)
                elif self.modalita == 'online':
                    self.switch[1].draw(156, 2)
                    if self.server == 1:
                        if self.pad.released_down and self.qualeVisLang < len(self.traduzionilang)-8 and len(self.traduzionilang) > 6:
                            self.qualeVisLang += 1
                        elif self.pad.released_up and self.qualeVisLang != 0:
                            self.qualeVisLang -= 1

                if osl.oskIsActive():
                    self.updateOSK()
                if self.connecting == True:
                    if osl.getDialogType():
                        osl.drawDialog()
                        if osl.getDialogStatus() == 0 and osl.dialogGetResult() != osl.DIALOG_CANCEL: # Connected.
                            self.connected = True
                            self.connecting = False
                            self.modalita = 'online'
                        elif osl.dialogGetResult() == osl.DIALOG_CANCEL:
                            self.modalita = 'offline'
                            self.connecting = False

                self.l_r.draw()
                
                if self.showChron == True:
                    self.box_chron.draw(480/2-200, 136-(246/2))
                    if len(self.chron) != 0:
                        osl.drawString(480/2-200+347, 136-(246/2)+11, "%d/%d"%(self.showChronIndex+1,len(self.chron)))
                    osl.drawString(480/2-200+123, 136-(246/2)+222, "Press Triagle to return.")
                    if self.showChronIndex != len(self.chron)-1:
                        osl.drawString(480/2-200+365, 136-(246/2)+222, "->")
                    if self.showChronIndex != 0:
                        osl.drawString(480/2-200+21, 136-(246/2)+222, "<-")
                    if len(self.chron) != 0:
                        y = 136-(246/2)+30
                        for line in self.chron[self.showChronIndex].split("\n"):
                            osl.drawString(480/2-200+20, y, line)
                            y += 15
                    else:
                        osl.drawString(480/2-200+20, 136-(246/2)+50, "There is no chronology available.")
                    
                osl.endDrawing()
            osl.endFrame() 
            skip = osl.syncFrame() 
        osl.endGfx()
